'Oct 10, 2007

'Demo program 
'Uses an array of dynamic picture boxes to show the initla placement of cards 
'to start a game of free cell

Imports System.IO

Public Class FrmFreeCell

    Dim Card As Integer() = New Integer(51) {}          'array of car values 1 - 52
    Dim picCard As PictureBox() = New PictureBox(51) {} 'array of pictureboxes for display
    Dim mylocation As String                            'to remeber location of executable
    Dim MyRandom As Random = New Random                 'random number generator used for shuffling 

    '******************************************************************************************
    'initialize Card array to values 1 through 52 
    Private Sub FrmFreeCell_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim i As Integer

        mylocation = Directory.GetCurrentDirectory
        For i = 0 To Card.Length - 1
            Card(i) = i + 1
        Next
    End Sub

    '******************************************************************************************
    'shuffles cards then places pictureboxes in eight columns 
    Private Sub btnDeal_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDeal.Click
        Dim NewCard As Integer
        Dim i As Integer
        Dim j As Integer

        '******************************************
        'shuffling  -- for each card (loop over index i)
        For i = 0 To Card.Length - 1
            j = MyRandom.Next(0, 52)
            NewCard = Card(j)
            Card(j) = Card(i)
            Card(i) = NewCard
        Next

        Dim Border As Integer = 5       'number fo pixels between cards
        Dim VerticalStart = 150         'how far down on form to start
        Dim CardWidth As Integer = 80   'width of card

        'loop through cards to display
        For i = 0 To picCard.Length - 1
            picCard(i) = New PictureBox     'instantiate new picturebox
            Me.Controls.Add(picCard(i))     'add to form
            picCard(i).Width = CardWidth    'set its width
            picCard(i).Height = 115         'set its height

            'set its position
            'i Mod 8 goes 0,1,2,3,4,5,6,7,0,1,2,3,4,5,6,7,0,1,2,3,4,5,6,7, ...
            'use for column psoitioning
            'i \ 8 (integer division) goes 0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,...
            'use for row positioning
            picCard(i).Location = New Point(Border + (i Mod 8) * (CardWidth + Border), VerticalStart + (i \ 8) * 25)


            'put in image of card
            picCard(i).Image = Image.FromFile(mylocation & "\CardGifs\CARDS" & Card(i) & ".gif")
            picCard(i).SizeMode = PictureBoxSizeMode.StretchImage  'make image fit picturebox
            picCard(i).BringToFront()                               'put each new picturebiox "on top"
        Next

    End Sub
End Class
